ReportingExtension (Gradle API 2.9)
Date: 2015-11-17

Package: org.gradle.api.reporting

## [Java] Class ReportingExtension

- org.gradle.api.reporting.ReportingExtension

- A project extension named "reporting" that provides basic reporting settings and utilities.

  Example usage:

       reporting {
           baseDir "$buildDir/our-reports"
       }

  When implementing a task that produces reports, the location of where to generate reports should be obtained via the file(String) method of this extension.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `DEFAULT_REPORTS_DIR_NAME` | The default name of the base directory for all reports, relative to Project.getBuildDir ({@value}).
    `static String` | `NAME` | The name of this extension ("{@value}")

  - ### Constructor Summary

    Constructors
    Constructor and description
    `ReportingExtension (Project project)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `File` | `file(String path)` Creates a file object for the given path, relative to getBaseDir().
    `String` | `getApiDocTitle()`
    `File` | `getBaseDir()` The base directory for all reports
    `void` | `setBaseDir(Object baseDir)` Sets the base directory to use for all reports

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final String DEFAULT_REPORTS_DIR_NAME

      The default name of the base directory for all reports, relative to Project.getBuildDir ({@value}).

    - #### public static final String NAME

      The name of this extension ("{@value}")

  - ### Constructor Detail

    - #### public ReportingExtension(Project project)

  - ### Method Detail

    - #### public File file(String path)

      Creates a file object for the given path, relative to getBaseDir().

      The reporting base dir can be changed, so users of this method should use it on demand where appropriate.

      Parameters:
        `path` - the relative path
      Returns:
        a file object at the given path relative to getBaseDir()

    - #### public String getApiDocTitle()

    - #### public File getBaseDir()

      The base directory for all reports

      This value can be changed, so any files derived from this should be calculated on demand.

      Returns:
        The base directory for all reports

    - #### public void setBaseDir(Object baseDir)

      Sets the base directory to use for all reports

      The value will be converted to a `File` on demand via Project.file.

      Parameters:
        `baseDir` - The base directory to use for all reports